diff -u arc2/news.arc arc3/news.arc
--- arc2/news.arc	2008-02-24 20:39:48.000000000 -0500
+++ arc3/news.arc	2009-05-30 17:09:15.000000000 -0400
@@ -1188,87 +1647,225 @@
 ; Note that ban tests are only applied when a link or comment is
 ; submitted, not each time it's edited.  This will do for now.
 
-(def ban-test (user i ip string kill-list ignore-list)
+(def story-ban-test (user i ip url)
+  (site-ban-test user i url)
+  (ip-ban-test i ip)
+  (hook 'story-ban-test user i ip url))
+
+(def site-ban-test (user i url)
+  (whenlet ban (banned-sites* (sitename url))
+    (when (caris ban 'ignore)
+      (set (ignored user))
+      (save-prof user))
+    (kill i 'banned-site)))
+
+(def ip-ban-test (i ip)
+  (when (banned-ips* ip)
+    (kill i 'banned-ip)))
+
+(def comment-ban-test (user i ip string kill-list ignore-list)
   (when (some [posmatch _ string] ignore-list)
-    (assert (uvar user ignore))
+    (set (ignored user))
     (save-prof user))
-  (when (or (mem ip ip-ban*) (some [posmatch _ string] kill-list))
-    (kill i)))
+  (when (or (banned-ips* ip) (some [posmatch _ string] kill-list))
+    (kill i 'banned)))
 
-(def killallby (user) (map kill (submissions user)))
+; An IP is banned when multiple ignored users have submitted over
+; ban-threshold* (currently loaded) dead stories from it.  
+
+; Can consider comments too if that later starts to be a problem,
+; but the threshold may start to be higher because then you'd be
+; dealing with trolls rather than spammers.
+
+(def maybe-ban-ip (s)
+  (when (and s!dead (ignored s!by))
+    (let bads (loaded-items [and _!dead (astory _) (is _!ip s!ip)])
+      (when (and (len> bads ip-ban-threshold*)
+                 (some [and (ignored _!by) (isnt _!by s!by)] bads))
+        (set-ip-ban nil s!ip t)))))
+
+(def killallby (user) 
+  (map [kill _ 'all] (submissions user)))
 
 ; Only called from repl.
 
 (def kill-whole-thread (c)
-  (kill c)
+  (kill c 'thread)
   (map kill-whole-thread:item c!kids))
 
-; Could be stricter.
 
-(def valid-url (url)
-  (and (len> url 10) 
-       (begins url "http://")
-       (~find [in _ #\< #\> #\"] url)))
+; Polls
 
-(def parse-site (url)
-  (rev (tokens (cadr (tokens url [in _ #\/ #\?])) #\.)))
-
-(defmemo sitename (url)
-  (let toks (parse-site url)
-    (if (isa (saferead (car toks)) 'int)
-        (tostring (prall toks "" "."))
-        (let (t1 t2 t3 . rest) toks  
-          (if (or (mem t1 multi-tld-countries*) 
-                  (and t3 (mem t2 long-domains*)))
-              (string t3 "." t2 "." t1)
-              (string t2 "." t1))))))
-
-; Minor bug: can have both google.at and google.co.at.  Same for jp.
+; a way to add a karma threshold for voting in a poll
+;  or better still an arbitrary test fn, or at least pair of name/threshold.
+; option to sort the elements of a poll when displaying
+; exclusive field? (means only allow one vote per poll)
+
+(= poll-threshold* 20)
+
+(newsop newpoll ()
+  (if (and user (> (karma user) poll-threshold*))
+      (newpoll-page user)
+      (pr "Sorry, you need at least " 
+           poll-threshold* 
+           " karma to create a poll.")))
+  
+(def newpoll-page (user (o title "Poll: ") (o text "") (o opts "") (o msg))
+  (minipage "New Poll"
+    (pagemessage msg)
+    (urform user req
+            (process-poll (get-user req)
+                          (striptags (arg req "t"))
+                          (md-from-form (arg req "x") t)
+                          (striptags (arg req "o"))
+                          req!ip)
+      (tab   
+        (row "title"   (input "t" title 50))
+        (row "text"    (textarea "x" 4 50 (only.pr text)))
+        (row ""        "Use blank lines to separate choices:")
+        (row "choices" (textarea "o" 7 50 (only.pr opts)))
+        (row ""        (submit))))))
+
+(= fewopts* "A poll must have at least two options.")
+
+(def process-poll (user title text opts ip)
+  (if (or (blank title) (blank opts))
+       (flink [newpoll-page user title text opts retry*])
+      (len> title title-limit*)
+       (flink [newpoll-page user title text opts toolong*])
+      (len< (paras opts) 2)
+       (flink [newpoll-page user title text opts fewopts*])
+      (atlet p (create-poll (multisubst scrubrules* title) text opts user ip)
+        (ip-ban-test p ip)
+        (when (ignored user) (kill p 'ignored))
+        (submit-item user p)
+        (maybe-ban-ip p)
+        "newest")))
+
+(def create-poll (title text opts user ip)
+  (newslog ip user 'create-poll title)
+  (let p (inst 'item 'type 'poll 'id (new-item-id)
+                     'title title 'text text 'by user 'ip ip)
+    (= p!parts (map get!id (map [create-pollopt p nil nil _ user ip]
+                                (paras opts))))
+    (save-item p)
+    (= (items* p!id) p)
+    (push p stories*)
+    p))
+
+(def create-pollopt (p url title text user ip)
+  (let o (inst 'item 'type 'pollopt 'id (new-item-id)
+                     'url url 'title title 'text text 'parent p!id
+                     'by user 'ip ip)
+    (save-item o)
+    (= (items* o!id) o) 
+    o))
 
-(= multi-tld-countries* '("uk" "jp" "au" "in" "ph" "tr" "za" "my" "nz" "br" 
-                          "mx" "th" "sg" "id" "pk" "eg" "il" "at"))
+(def add-pollopt-page (p user)
+  (minipage "Add Poll Choice"
+    (urform user req
+            (do (add-pollopt user
+                             p 
+                             (striptags (arg req "x"))
+                             req!ip)
+                (item-url p!id))
+      (tab
+        (row "text" (textarea "x" 4 50))
+        (row ""     (submit))))))
 
-(= long-domains* '("blogspot" "wordpress" "livejournal" "blogs" "typepad" 
-                   "weebly" "blog-city" "com"))
+(def add-pollopt (user p text ip)
+  (unless (blank text)
+    (atlet o (create-pollopt p nil nil text user ip)
+      (= p!parts (+ p!parts (list o!id)))
+      (save-item p))))
+
+(def display-pollopts (p user whence)
+  (each o (visible user (map item p!parts))
+    (display-pollopt nil o user whence)
+    (spacerow 7)))
 
-(def create-story (url title text user ip)
-  (newslog user 'create url (list title))
-  (let s (inst 'item 'type 'story 'id (new-item-id) 
-                     'url url 'title title 'text text 'by user 'ip ip)
-    (save-item s)
-    (= (items* s!id) s (url->story* url) s)
-    (push s stories*)
-    s))
+(def display-pollopt (n o user whence)
+  (tr (display-item-number n)
+      (tag (td valign 'top)
+        (votelinks o user whence))
+      (tag (td class 'comment)
+        (tag (div style "margin-top:1px;margin-bottom:0px")
+          (if (~cansee user o) (pr (pseudo-text o))
+              (~live o)        (spanclass dead 
+                                 (pr (if (~blank o!title) o!title o!text)))
+                               (if (and (~blank o!title) (~blank o!url))
+                                   (link o!title o!url)
+                                   (fontcolor black (pr o!text)))))))
+  (tr (if n (td))
+      (td)
+      (tag (td class 'default)
+        (spanclass comhead
+          (itemscore o)
+          (editlink o user)
+          (killlink o user whence)
+          (deletelink o user whence)
+          (deadmark o user)))))
 
 
 ; Individual Item Page (= Comments Page of Stories)
 
-(def item-url (story) (string "item?id=" (story 'id)))
+(defmemo item-url (id) (string "item?id=" id))
 
 (newsop item (id)
   (let s (safe-item id)
     (if (news-type s)
-        (item-page user s)
-        (pr "No such item."))))
+        (do (if s!deleted (note-baditem user ip))
+            (item-page user s))
+        (do (note-baditem user ip)
+            (pr "No such item.")))))
+
+(= baditemreqs* (table) baditem-threshold* 1/100)
+
+; Something looking at a lot of deleted items is probably the bad sort
+; of crawler.  Throttle it for this server invocation.
+
+(def note-baditem (user ip)
+  (unless (admin user)
+    (++ (baditemreqs* ip 0))
+    (with (r (requests/ip* ip) b (baditemreqs* ip))
+       (when (and (> r 500) (> (/ b r) baditem-threshold*))
+         (set (throttle-ips* ip))))))
+
+; redefined later
 
-(def news-type (s) 
-  (and s (or (storylike s) (acomment s))))
+(def news-type (i) (and i (in i!type 'story 'comment 'poll 'pollopt)))
 
 (def item-page (user i)
   (with (title (and (cansee user i)
                     (or i!title (aand i!text (ellipsize (striptags it)))))
-         here (item-url i))
-    (shortpage user nil title here
+         here (item-url i!id))
+    (shortpage user nil nil title here
       (tab (display-item nil i user here)
            (display-item-text i user)
-           (when (and (cansee user i) (live i) (commentable i))
+           (when (apoll i)
+             (spacerow 10)
+             (tr (td)
+                 (td (tab (display-pollopts i user here)))))
+           (when (and (cansee user i) (comments-active i))
              (spacerow 10)
              (row "" (comment-form i user here))))
       (br2) 
       (when (and i!kids (commentable i))
         (tab (display-subcomments i user here))))))
 
-(def commentable (i) (in i!type 'comment 'story))
+(def commentable (i) (in i!type 'story 'comment 'poll))
+
+; By default the ability to comment on an item is turned off after 
+; 45 days, but this can be overriden with commentable key.
+
+(= commentable-threshold* (* 60 24 45))
+
+(def comments-active (i)
+  (and (live i)
+       (commentable i)
+       (or (< (item-age i) commentable-threshold*)
+           (mem 'commentable i!keys))))
+
 
 (= displayfn* (table))
 
@@ -1278,6 +1875,11 @@
 (= (displayfn* 'comment) (fn (n i user here inlist)
                            (display-comment n i user here nil 0 nil inlist)))
 
+(= (displayfn* 'poll)    (displayfn* 'story))
+
+(= (displayfn* 'pollopt) (fn (n i user here inlist)
+                           (display-pollopt n i user here)))
+
 (def display-item (n i user here (o inlist))
   ((displayfn* (i 'type)) n i user here inlist))
 
@@ -1285,21 +1887,24 @@
   (aif i!parent (superparent:item it) i))
 
 (def display-item-text (s user)
-  (when (and (cansee user s) (astory s) (blank s!url) (~blank s!text))
+  (when (and (cansee user s) 
+             (in s!type 'story 'poll)
+             (blank s!url) 
+             (~blank s!text))
     (spacerow 2)
     (row "" s!text)))
 
 
 ; Edit Item
 
-(def edit-url (story) (string "edit?id=" (story 'id)))
+(def edit-url (i) (string "edit?id=" i!id))
 
 (newsop edit (id)
   (let i (safe-item id)
     (if (and i 
              (cansee user i)
              (editable-type i)
-             (or (news-type i) (admin user) (is user i!by)))
+             (or (news-type i) (admin user) (author user i)))
         (edit-page user i)
         (pr "No such item."))))
 
@@ -1318,35 +1923,82 @@
          (int     sockvotes ,(s 'sockvotes)   ,e ,a)
          (yesno   dead      ,(s 'dead)        ,e ,e)
          (yesno   deleted   ,(s 'deleted)     ,a ,a)
+         (sexpr   flags     ,(s 'flags)       ,a nil)
+         (sexpr   keys      ,(s 'keys)        ,a ,a)
          (string  ip        ,(s 'ip)          ,e  nil)))))
 
 (= (fieldfn* 'comment)
    (fn (user s)
      (with (a (admin user)  e (editor user)  x (canedit user s))
        `((mdtext  text      ,(s 'text)         t ,x)
+         (int     votes     ,(len (s 'votes)) ,a  nil)
+         (int     score     ,(s 'score)        t ,a)
+         (int     sockvotes ,(s 'sockvotes)   ,e ,a)
+         (yesno   dead      ,(s 'dead)        ,e ,e)
+         (yesno   deleted   ,(s 'deleted)     ,a ,a)
+         (sexpr   flags     ,(s 'flags)       ,a nil)
+         (sexpr   keys      ,(s 'keys)        ,a ,a)
+         (string  ip        ,(s 'ip)          ,e  nil)))))
+
+(= (fieldfn* 'poll)
+   (fn (user s)
+     (with (a (admin user)  e (editor user)  x (canedit user s))
+       `((string1 title     ,(s 'title)        t ,x)
+         (mdtext2 text      ,(s 'text)         t ,x)
+         (int     votes     ,(len (s 'votes)) ,a  nil)
          (int     score     ,(s 'score)        t ,a)
          (int     sockvotes ,(s 'sockvotes)   ,e ,a)
          (yesno   dead      ,(s 'dead)        ,e ,e)
          (yesno   deleted   ,(s 'deleted)     ,a ,a)
+         (sexpr   flags     ,(s 'flags)       ,a nil)
+         (sexpr   keys      ,(s 'keys)        ,a ,a)
+         (string  ip        ,(s 'ip)          ,e  nil)))))
+
+(= (fieldfn* 'pollopt)
+   (fn (user s)
+     (with (a (admin user)  e (editor user)  x (canedit user s))
+       `((string  title     ,(s 'title)        t ,x)
+         (url     url       ,(s 'url)          t ,x)
+         (mdtext2 text      ,(s 'text)         t ,x)
+         (int     votes     ,(len (s 'votes)) ,a  nil)
+         (int     score     ,(s 'score)        t ,a)
+         (int     sockvotes ,(s 'sockvotes)   ,e ,a)
+         (yesno   dead      ,(s 'dead)        ,e ,e)
+         (yesno   deleted   ,(s 'deleted)     ,a ,a)
+         (sexpr   flags     ,(s 'flags)       ,a nil)
+         (sexpr   keys      ,(s 'keys)        ,a ,a)
          (string  ip        ,(s 'ip)          ,e  nil)))))
 
 ; Should check valid-url etc here too.  In fact make a fn that
 ; does everything that has to happen after submitting a story,
 ; and call it both there and here.
 
-(def edit-page (user s)
-  (let here (edit-url s)
-    (shortpage user nil "Edit" here
-      (tab (display-item nil s user here)
-           (display-item-text s user))
+(def edit-page (user i)
+  (let here (edit-url i)
+    (shortpage user nil nil "Edit" here
+      (tab (display-item nil i user here)
+           (display-item-text i user))
       (br2)
       (vars-form user
-                 ((fieldfn* s!type) user s)
-                 (fn (name val) (= (s name) val))
-                 (fn () (save-item s)
-                        (if (storylike s) (adjust-rank s))
-                        (edit-page user s)))
-      (hook 'edit user s))))
+                 ((fieldfn* i!type) user i)
+                 (fn (name val) 
+                   (unless (ignore-edit user i name val)
+                     (when (and (is name 'dead) val (no i!dead))
+                       (log-kill i user))
+                     (= (i name) val)))
+                 (fn () (if (admin user) (pushnew 'locked i!keys))
+                        (save-item i)
+                        (if (metastory i) (adjust-rank i))
+                        (wipe (comment-cache* i!id))
+                        (edit-page user i)))
+      (hook 'edit user i))))
+
+(def ignore-edit (user i name val)
+  (or (and (is name 'title) 
+           (len> val title-limit*))
+      (and (is name 'dead) 
+           (mem 'nokill i!keys) 
+           (~admin user))))
 
  
 ; Comment Submission
@@ -1355,7 +2007,7 @@
   (login-page 'both "You have to be logged in to comment."
               (fn (u ip)
                 (ensure-news-user u)
-                (newslog u 'comment-login ip)
+                (newslog ip u 'comment-login)
                 (addcomment-page parent u whence text))))
 
 (def addcomment-page (parent user whence (o text) (o msg))
@@ -1367,13 +2019,25 @@
       (spacerow 10)
       (row "" (comment-form parent user whence text)))))
 
+(= noob-comment-msg* nil)
+
+; Comment forms last for 30 min (- cache time)
+
 (def comment-form (parent user whence (o text))
-  (urform user req 
-          (process-comment (get-user req) parent (arg req "text") (req 'ip) whence)
-    (textarea "text" 6 60 
+  (timed-arform 1800
+                (fn (req)
+                  (when-umatch/r user req
+                    (process-comment (get-user req) parent (arg req "text") 
+                                     req!ip whence)))
+    (textarea "text" 6 60  
       (aif text (prn (unmarkdown it))))
+    (when (and noob-comment-msg* (noob user))
+      (br2)
+      (spanclass subtext (pr noob-comment-msg*)))
     (br2)
-    (submit (if (astory parent) "add comment" "reply"))))
+    (submit (if (acomment parent) "reply" "add comment"))))
+
+(= comment-threshold* -20)
 
 ; Have to remove #\returns because a form gives you back "a\r\nb"
 ; instead of just "a\nb".   Maybe should just remove returns from
@@ -1384,16 +2048,17 @@
        (flink [comment-login-warning parent whence text])
       (empty text)
        (flink [addcomment-page parent (get-user _) whence text retry*])
+      (oversubmitting user ip 'comment)
+       (flink [msgpage user toofast*])
        (atlet c (create-comment parent (md-from-form text) user ip)
-         (ban-test user c ip text comment-kill* comment-ignore*)
-         (when (uvar user ignore) (kill c))
-         (push c!id (uvar user submitted))
-         (save-prof user)
-         (vote-for user c)
+         (comment-ban-test user c ip text comment-kill* comment-ignore*)
+         (when (or (ignored user) (< (karma user) comment-threshold*))
+           (kill c 'ignored/karma))
+         (submit-item user c)
          whence)))
 
 (def create-comment (parent text user ip)
-  (newslog user 'comment (parent 'id))
+  (newslog ip user 'comment (parent 'id))
   (let c (inst 'item 'type 'comment 'id (new-item-id)
                      'text text 'parent parent!id 'by user 'ip ip)
     (save-item c)
@@ -1409,7 +2074,7 @@
 (def display-comment-tree (c user whence (o indent 0) (o initialpar))
   (when (cansee-descendant user c)
     (display-1comment c user whence indent initialpar)
-    (display-subcomments c user whence (+ indent 40))))
+    (display-subcomments c user whence (+ indent 1))))
 
 (def display-1comment (c user whence indent showpar)
   (row (tab (display-comment nil c user whence t indent showpar showpar))))
@@ -1423,88 +2088,193 @@
 (def display-comment (n c user whence (o astree) (o indent 0) 
                                       (o showpar) (o showon))
   (tr (display-item-number n)
-      (when astree (td (hspace indent)))
+      (when astree (td (hspace (* indent 40))))
       (tag (td valign 'top)
         (votelinks c user whence t))
-      (tag (td class 'default)
-        (let parent (and (or (no astree) showpar) (c 'parent))
-          (spanclass comhead
-            (itemline c user)
-            (permalink c user)
-            (when parent
-              (when (cansee user c) (pr bar*))
-              (link "parent" (item-url (item parent))))
-            (editlink c user)
-            (deletelink c user whence)
-            (deadmark c user)
-            (when showon
-              (pr " | on: ")
-              (let s (superparent c)
-                (link (ellipsize s!title 50) 
-                      (if (empty s!url) (item-url s) s!url)))))
-          (when (or parent (cansee user c))
-            (br) (vspace 20))
-          (spanclass comment
-            (if (no (cansee user c))
-                 (pr (pseudo-text c))
-                (and (no (live c)) (isnt user c!by))
-                 (spanclass dead (pr c!text))
-                 (tag (font color (comment-color c))
-                   (pr c!text))))
-          (when (and astree (cansee user c) (live c))
-            (para)
-            (tag (font size 1)
-              (underline (replylink c user whence))))))))
-
-(def replylink (i user whence (o title 'reply))
-  (linkf title (req)
-    (let user (get-user req)
-      (if user
-          (addcomment-page i user whence)
-          (login-page 'both "You have to be logged in to comment."
-                      (fn (u ip)
-                        (ensure-news-user u)
-                        (newslog u 'comment-login ip)
-                        (addcomment-page i u whence)))))))
+      (display-comment-body c user whence astree indent showpar showon)))
+
+; Comment caching doesn't make generation of comments significantly
+; faster, but may speed up everything else by generating less garbage.
+
+; It might solve the same problem more generally to make html code
+; more efficient.
+
+(= comment-cache* (table) comment-cache-timeout* (table)
+   cc-window* 10000)
+
+(= comments-printed* 0 cc-hits* 0)
+
+(= comment-caching* t) 
+
+; Cache comments generated for nil user that are over an hour old.
+; Only try to cache most recent 10k items.  But this window moves,
+; so if server is running a long time could have more than that in
+; cache.  Probably should actively gc expired cache entries.
+
+(def display-comment-body (c user whence astree indent showpar showon)
+  (++ comments-printed*)
+  (if (and comment-caching*
+           astree (no showpar) (no showon)
+           (live c)
+           (nor (admin user) (editor user) (author user c))
+           (< (- maxid* c!id) cc-window*)
+           (> (- (seconds) c!time) 60)) ; was 3600
+      (pr (cached-comment-body c user whence indent))
+      (gen-comment-body c user whence astree indent showpar showon)))
+
+(def cached-comment-body (c user whence indent)
+  (or (and (> (or (comment-cache-timeout* c!id) 0) (seconds))
+           (awhen (comment-cache* c!id)
+             (++ cc-hits*)
+             it))
+      (= (comment-cache-timeout* c!id)
+          (cc-timeout c!time)
+         (comment-cache* c!id)
+          (tostring (gen-comment-body c user whence t indent nil nil)))))
+
+; Cache for the remainder of the current minute, hour, or day.
+
+(def cc-timeout (t0)
+  (let age (- (seconds) t0)
+    (+ t0 (if (< age 3600)
+               (* (+ (trunc (/ age    60)) 1)    60)
+              (< age 86400)
+               (* (+ (trunc (/ age  3600)) 1)  3600)
+               (* (+ (trunc (/ age 86400)) 1) 86400)))))
+
+(def gen-comment-body (c user whence astree indent showpar showon)
+  (tag (td class 'default)
+    (let parent (and (or (no astree) showpar) (c 'parent))
+      (tag (div style "margin-top:2px; margin-bottom:-10px; ")
+        (spanclass comhead
+          (itemline c user)
+          (permalink c user)
+          (when parent
+            (when (cansee user c) (pr bar*))
+            (link "parent" (item-url ((item parent) 'id))))
+          (editlink c user)
+          (when (admin user) 
+            (killlink c user whence)
+            (blastlink c user whence))
+          (deletelink c user whence)
+          ; a hack to check whence but otherwise need an arg just for this
+          (unless (or astree (is whence "newcomments"))
+            (flaglink c user whence))
+          (deadmark c user)
+          (when showon
+            (pr " | on: ")
+            (let s (superparent c)
+              (link (ellipsize s!title 50) (item-url s!id))))))
+      (when (or parent (cansee user c))
+        (br))
+      (spanclass comment
+        (if (~cansee user c)               (pr (pseudo-text c))
+            (nor (live c) (author user c)) (spanclass dead (pr c!text))
+                                           (fontcolor (comment-color c)
+                                             (pr c!text))))
+      (when (and astree 
+                 (cansee user c) 
+                 (live c))
+        (para)
+        (tag (font size 1)
+          (if (and (~mem 'neutered c!keys)
+                   (replyable c indent)
+                   (comments-active c))
+              (underline (replylink c whence))
+              (fontcolor sand (pr "-----"))))))))
+
+; For really deeply nested comments, caching could add another reply 
+; delay, but that's ok.
+
+; People could beat this by going to the link url or manually entering 
+; the reply url, but deal with that if they do.
+
+(= reply-decay* 1.8)   ; delays: (0 0 1 3 7 12 18 25 33 42 52 63)
+
+(def replyable (c indent)
+  (or (< indent 2)
+      (> (item-age c) (expt (- indent 1) reply-decay*))))
+
+(def replylink (i whence (o title 'reply))
+  (link title (string "reply?id=" i!id "&whence=" (urlencode whence))))
+
+(newsop reply (id whence)
+  (with (i      (safe-item id)
+         whence (if whence (urldecode whence) "news"))
+    (if (and i (comments-active i))
+        (if user
+            (addcomment-page i user whence)
+            (login-page 'both "You have to be logged in to comment."
+                        (fn (u ip)
+                          (ensure-news-user u)
+                          (newslog ip u 'comment-login)
+                          (addcomment-page i u whence))))
+        (pr "No such item."))))
 
 (def comment-color (c)
-  (let s (realscore c)
-    (if (> s 0)  black
-        (< s -2) (gray 150)
-                 (case s -2 (gray 130) -1 (gray  90) 0 (gray  50)))))
+  (if (> c!score 0) black (grayrange c!score)))
+
+(defmemo grayrange (s)
+  (gray (min 230 (round (expt (* (+ (abs s) 2) 900) .6)))))
 
 
 ; Threads
 
-(def threads-url (user) (string "threads?id=" user))
+(def threads-url (user) (+ "threads?id=" user))
 
-(newsop threads (id) (threads-page user id))
+(newsop threads (id) 
+  (if id
+      (threads-page user id)
+      (pr "No user specified.")))
 
 (def threads-page (user subject)
-  (if (profs* subject)
-      (withs (title (string subject "'s comments")
+  (if (profile subject)
+      (withs (title (+ subject "'s comments")
               label (if (is user subject) "threads" title)
               here  (threads-url subject))
-        (longpage user (msec) label title here
+        (longpage user (msec) nil label title here
           (awhen (keep [and (cansee user _) (no (subcomment _))]
-                       (comments subject perpage*))
-            (tab (each c it
-                   (display-comment-tree c user here 0 t))))))
+                       (comments subject maxend*))
+            (display-threads user it label title here))))
       (prn "No such user.")))
 
+(def display-threads (user comments label title whence
+                      (o start 0) (o end threads-perpage*))
+  (tab 
+    (let n start
+      (each c (cut comments start end)
+        (display-comment-tree c user whence 0 t)))
+    (when end
+      (let newend (+ end threads-perpage*)
+        (when (and (<= newend maxend*) (< end (len comments)))
+          (spacerow 10)
+          (row (tab (tr (td (hspace 0))
+                        (td (hspace votewid*))
+                        (tag (td class 'title)
+                          (moreclink comments label title end newend))))))))))
+
+; Identical to morelink except missing number arg and 
+; display-items -> display-threads.  Try to unify.
+
+(def moreclink (comments label title end newend)
+  (tag (a href (url-for
+                 (afnid (fn (req)
+                          (prn)
+                          (let user (get-user req)
+                            (newslog req!ip user 'more label)
+                            (longpage user (msec) nil label title (url-for it)
+                              (display-threads user comments
+                                               label title (url-for it)
+                                               end newend))))))
+          rel 'nofollow)
+    (pr "More")))
+
 (def submissions (user (o limit)) 
   (map item (firstn limit (uvar user submitted))))
 
-(def comments (user (o limit)) 
-  ((afn (ids count)
-     (if (or (no ids) (is count limit))
-         nil
-         (let c (item (car ids))
-           (consif (and (acomment c) c)
-                   (self (cdr ids) 
-                         (+ count (if (acomment c) 1 0)))))))
-   (uvar user submitted) 0))
-     
+(def comments (user (o limit))
+  (map item (retrieve limit acomment:item (uvar user submitted))))
+  
 (def subcomment (c)
   (some [and (acomment _) (is _!by c!by) (no _!deleted)]
         (ancestors c)))
@@ -1517,19 +2287,22 @@
 
 ; Submitted
 
-(def submitted-url (user) (string "submitted?id=" user))
+(def submitted-url (user) (+ "submitted?id=" user))
        
-(newsop submitted (id) (submitted-page user id))
+(newsop submitted (id) 
+  (if id 
+      (submitted-page user id)
+      (pr "No user specified.")))
 
 (def submitted-page (user subject)
-  (if (profs* subject)
-      (with (label (string subject "'s submissions")
+  (if (profile subject)
+      (with (label (+ subject "'s submissions")
              here  (submitted-url subject))
-        (longpage user (msec) label label here
-          (if (or (no (uvar subject ignore))
+        (longpage user (msec) nil label label here
+          (if (or (no (ignored subject))
                   (is user subject)
                   (seesdead user))
-              (aif (keep [and (astory _) (cansee user _)]
+              (aif (keep [and (metastory _) (cansee user _)]
                          (submissions subject))
                    (display-items user it label label here 0 perpage* t)))))
       (pr "No such user.")))
@@ -1540,7 +2313,7 @@
 (newsop rss () (rsspage nil))
 
 (newscache rsspage user 90 
-  (rss-stories (firstn 25 ranked-stories*)))
+  (rss-stories (retrieve perpage* live ranked-stories*)))
 
 (def rss-stories (stories)
   (tag (rss version "2.0")
@@ -1550,7 +2323,7 @@
       (tag description (pr site-desc*))
       (each s stories
         (tag item
-          (let comurl (+ site-url* (item-url s))
+          (let comurl (+ site-url* (item-url s!id))
             (tag title    (pr (eschtml s!title)))
             (tag link     (pr (if (blank s!url) comurl (eschtml s!url))))
             (tag comments (pr comurl))
@@ -1564,25 +2337,64 @@
 
 (= nleaders* 20)
 
-(newscache leaderspage user 180
-  (longpage user (msec) "leaders" "Leaders" "leaders"
-    (zerotable
+(newscache leaderspage user 1000
+  (longpage user (msec) nil "leaders" "Leaders" "leaders"
+    (sptab
       (let i 0
         (each u (firstn nleaders* (leading-users))
-          (tr (tdright (pr (++ i) "."))
-              (td (hspace 7))
-              (td (underlink u (user-url u)))
-              (td (hspace 10))
-              (tdright (pr (karma u))))
+          (tr (tdr (pr (++ i) "."))
+              (td (userlink user u nil))
+              (tdr (pr (karma u)))
+              (when (admin user)
+                (tdr (aif (uvar u avg) (pr (num it 2 t t))))))
           (if (is i 10) (spacerow 30)))))))
 
+(= leader-threshold* 1)  ; redefined later
+
 (def leading-users ()
   (sort (compare > [karma _])
-        (users [and (> (karma _) 1) (~admin _)])))
+        (users [and (> (karma _) leader-threshold*) (~admin _)])))
 
 (adop editors ()
   (tab (each u (users [is (uvar _ auth) 1])
-         (row (link u (user-url u))))))
+         (row (userlink user u)))))
+
+
+(= update-avg-threshold* 0)  ; redefined later
+
+(defbg update-avg 45
+  (unless (or (empty profs*) (no stories*))
+    (update-avg (rand-user [and (only.> (car (uvar _ submitted)) 
+                                        (- maxid* initload*))
+                                (len> (uvar _ submitted) 
+                                      update-avg-threshold*)]))))
+
+(def update-avg (user)
+  (= (uvar user avg) (comment-score user))
+  (save-prof user))
+
+(def rand-user ((o test idfn))
+  (let u (rand-key profs*)
+    (if (test u) u (rand-user test))))
+
+; maybe promote to arc.arc 
+
+(def rand-key (h)
+  (if (empty h)
+      nil
+      (let n (rand (len h))
+        (catch 
+          (ontable k v h
+            (when (is (-- n) -1)
+              (throw k)))))))
+
+; Ignore the most recent 5 comments since they may still be gaining votes.  
+; Also ignore the highest-scoring comment, since possibly a fluff outlier.
+
+(def comment-score (user)
+  (aif (check (nthcdr 5 (comments user 50)) [len> _ 10])
+       (avg (cdr (sort > (map get!score (rem get!deleted it)))))
+       nil))
 
 
 ; Comment Analysis
@@ -1593,8 +2405,8 @@
 
 (newsop active () (active-page user))
 
-(newscache active-page user 90
-  (listpage user (msec) (actives user) "active" "Active Threads" "active" t))
+(newscache active-page user 600
+  (listpage user (msec) (actives user) "active" "Active Threads"))
 
 (def actives (user (o n maxend*) (o consider 2000))
   (visible user (rank-stories n consider (memo active-rank))))
